package coffeetronix;

import java.awt.FlowLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JPanel;


/**
 * This is just the panel with the 8 tool buttons
 *  ( Projects..., Quick Save, Reload, Export, Exit).
 *
 * @author Rene Stoeckel (rene.stoeckel-at-web.de)
 */

public class CoffeeToolBar extends JPanel
{
	private Coffeetronix ctx= null;
	private JButton bprojects= new JButton();
	private JButton bsave= new JButton();
	private JButton breload= new JButton();
	private JButton bexit= new JButton();
	private FlowLayout flowLayout1= new FlowLayout();
	private JButton bconsole= new JButton();
	private JButton bexport= new JButton();
	private JButton bimport= new JButton();
    private JButton bexportgif = new JButton();

	public CoffeeToolBar(Coffeetronix ctx)
	{
		this.ctx= ctx;
		try
		{
			jbInit();
		}
		catch (Exception e)
		{
			e.printStackTrace();
		}
	}
	private void jbInit() throws Exception
	{
		bprojects.setMargin(new Insets(1, 1, 1, 1));
		bprojects.setText("Projects...");
		bprojects.addActionListener(new java.awt.event.ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				bprojects_actionPerformed(e);
			}
		});
		this.setLayout(flowLayout1);
		bsave.setMargin(new Insets(1, 1, 1, 1));
		bsave.setText("Quick save");
		bsave.addActionListener(new java.awt.event.ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				bsave_actionPerformed(e);
			}
		});
		breload.setMargin(new Insets(1, 1, 1, 1));
		breload.setText("Reload");
		breload.addActionListener(new java.awt.event.ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				breload_actionPerformed(e);
			}
		});
		bexit.setMargin(new Insets(1, 1, 1, 1));
		bexit.setText("Exit");
		bexit.addActionListener(new java.awt.event.ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				bexit_actionPerformed(e);
			}
		});
		this.setBorder(BorderFactory.createEtchedBorder());
		bconsole.addActionListener(new java.awt.event.ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				bconsole_actionPerformed(e);
			}
		});
		bconsole.setMargin(new Insets(1, 1, 1, 1));
		bconsole.setText("Console...");
		bexport.setText("Export TXT");
		bexport.setMargin(new Insets(1, 1, 1, 1));
		bexport.addActionListener(new java.awt.event.ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				bexport_actionPerformed(e);
			}
		});
		bimport.setMargin(new Insets(1, 1, 1, 1));
		bimport.setText("Import TXT");
		bimport.addActionListener(new java.awt.event.ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				bimport_actionPerformed(e);
			}
		});
		bexportgif.setMargin(new Insets(1, 1, 1, 1));
        bexportgif.setText("Export GIF");
        bexportgif.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                bexportgif_actionPerformed(e);
            }
        });
        this.add(bprojects);
		this.add(bsave);
		this.add(breload);
		this.add(bconsole, null);
        this.add(bexportgif, null);
		this.add(bexport, null);
		this.add(bimport, null);
		this.add(bexit);
	}

	void bprojects_actionPerformed(ActionEvent e)
	{
		ctx.projectslist.show();
	}

	void bsave_actionPerformed(ActionEvent e)
	{
		ctx.projectslist.action_save(e);
	}

	void breload_actionPerformed(ActionEvent e)
	{
		ctx.projectslist.reload();
	}

	void bexit_actionPerformed(ActionEvent e)
	{
		System.out.println("bye bye!");
		System.exit(0);
	}

	void bconsole_actionPerformed(ActionEvent e)
	{
		ctx.logwindow.show();
	}

	void bexport_actionPerformed(ActionEvent e)
	{
		System.out.println("hello world!");
		ctx.diagrampanel.export("c:\\test.ctc");
	}

	void bimport_actionPerformed(ActionEvent e)
	{
		try
		{
			ctx.diagrampanel.imports(new BufferedReader(new FileReader("c:\\test.ctc")));
		}
		catch (FileNotFoundException e1)
		{
			e1.printStackTrace();
		}
	}

    void bexportgif_actionPerformed(ActionEvent e)
    {
		ctx.diagrampanel.exportgfx();
    }
}
