package coffeetronix;

/** This is for error handling, log4j should be used in future.
 *  It is done to switch easily between stdout and consolewindow. 
 */

public class ErrorSystem
{
	public final static int FAILED = 0;
	public final static int WARNINGS = 2;
	public final static int OK = 1;

	private static ErrorHandler errorhandler;

	public static void setErrorHandler(ErrorHandler e)
	{
		errorhandler = e;
	}

	interface ErrorHandler
	{
		void error(String s);
		void info(String s);
		void warning(String s);
		void fatalerror(String s);
	}

	public static void fatalerror(String s)
	{
		// this could pop up a message end exit then.
		if (errorhandler == null)
					System.err.println(s);
				else
					errorhandler.error(s);

	}

	public static void error(String s)
	{
		if (errorhandler == null)
			System.err.println(s);
		else
			errorhandler.error(s);

	}
	
	public static void warning(String s)
	{
		if (errorhandler == null)
			System.err.println(s);
		else
			errorhandler.warning(s);
	}

	public static void info(String s)
	{
		if (errorhandler == null)
			System.out.println(s);
		else
			errorhandler.info(s);
	}

}

