package coffeetronix;

import java.util.Iterator;
import java.util.LinkedList;

/**
 * 
 *  Holds the java fields of a class, holds also information (access modifiers, type, 
 * 	etc...) about java attributes (multiple attributes) keeps a list of their names.
 * 
 * @author Rene Stoeckel (rene.stoeckel-at-web.de)
 */

public class JavaAttribute implements Cloneable
{
	/** 0=public, 1=protected, 2=private */
	private int protection= 0;
	private boolean isstatic= false;
	private boolean isfinal= false;
	private boolean istransient= false;
	private boolean isvolatile= false;

	private int lineno= 1;
	private String type;
	private String name= "xxx";

	private LinkedList names= new LinkedList();

	public void setType(String str)
	{
		type= str;
	}

	public void setLine(int lineno)
	{
		this.lineno= lineno;
	}

	public void addName(String str)
	{
		names.add(str);
	}

	public void setName(String namestr)
	{
		this.name= namestr;
	}

	public LinkedList getSingleAttributes()
	{

		LinkedList list= new LinkedList();

		for (Iterator iter= names.iterator(); iter.hasNext();)
		{
			String namestr= (String) iter.next();
			JavaAttribute attr= new JavaAttribute();

			attr.setName(namestr);
			attr.setType(type);
			attr.setLine(lineno);
			attr.setProtection(protection);
			attr.setStatic(isstatic);
			attr.setFinal(isfinal);
			attr.setTransient(istransient);
			attr.setVolatile(isvolatile);

			list.add(attr);
		}

		return list;
	}

	public void setProtection(int proti)
	{
		protection= proti;
	}

	public int getProtection()
	{
		return protection;
	}

	public void setStatic(boolean stati)
	{
		this.isstatic= stati;
	}

	public void setFinal(boolean fini)
	{
		this.isfinal= fini;
	}

	public void setTransient(boolean transi)
	{
		this.istransient= transi;
	}

	public void setVolatile(boolean voli)
	{
		this.isvolatile= voli;
	}

	public String toString()
	{
		return type + " " + name;
	}

	public int compareTo(JavaAttribute attrib2)
	{
		return toString().compareTo(attrib2.toString());
	}
}
